let gd = Object.create(null);
let log = false;

function onResponse(response) {

	try 
	{
		let data = JSON.parse(response);
		
		if (!log)
		console.log(data.message);
	}
	catch(e)
	{
		
		console.log("error: " + e.message);

	}



}

function onError(error) {

	console.log("error: " + error);

}


function call_goldendict(info, tab)
{


	let q = info.selectionText.trim().replace(/"/g, "");

	if (q.length > 0)
	{

		if ((gd.settings) && (gd.settings.gn || gd.settings.pgn))
		{
			

			let detecting = browser.tabs.detectLanguage();
			
			detecting.then((lng)=>{


				if ((gd.settings) && (lng !== "und"))
				{
					
					let param1 = (gd.settings.gn) ? lng : "";
					
					if (param1 !== "")
					param1 = (gd.settings.tab[param1]) ? "--group-name=" + gd.settings.tab[param1] : "";

					let param2 = (gd.settings.pgn) ? lng : "";
					
					if (param2 !== "")
					param2 = (gd.settings.tab[param2]) ? "--popup-group-name=" + gd.settings.tab[param2] : "";


					let cmd = `goldendict ${param1} ${param2} "${q}"`.replace(/\s{2,}/g, " ");
					
					if (!log)
					console.log("sending (1): " + cmd);
		
					let sending = browser.runtime.sendNativeMessage(
					"goldendict_helper",
					JSON.stringify({"cmd": cmd}));
					sending.then(onResponse, onError);
					
				}
				else if ((gd.settings) && (lng === "und"))
				{

					let param1 = ((gd.settings.gn) && (gd.settings.tab["none"])) ? "--group-name=" + gd.settings.tab["none"] : "";
					let param2 = ((gd.settings.pgn) && (gd.settings.tab["none"])) ? "--popup-group-name=" + gd.settings.tab["none"] : "";

					let cmd = `goldendict ${param1} ${param2} "${q}"`.replace(/\s{2,}/g, " ");
					
					if (!log)
					console.log("sending (2): " + cmd);

					let sending = browser.runtime.sendNativeMessage(
					"goldendict_helper",
					JSON.stringify({"cmd": cmd}));
					sending.then(onResponse, onError);
					
				}
				else
				{

					let cmd = `goldendict "${q}"`;

					if (!log)
					console.log("sending (3): " + cmd);

					let sending = browser.runtime.sendNativeMessage(
					"goldendict_helper",
					JSON.stringify({"cmd": cmd}));
					sending.then(onResponse, onError);

				}
			
				
			}, (error)=>{
					
				console.log(`Error: ${error}`);	

				let cmd = `goldendict "${q}"`;

				if (!log)
				console.log("sending (4): " + cmd);

				let sending = browser.runtime.sendNativeMessage(
				"goldendict_helper",
				JSON.stringify({"cmd": cmd}));
				sending.then(onResponse, onError);


					
					
			});
			
			
		}
		else
		{
			
			let cmd = `goldendict "${q}"`;

			if (!log)
			console.log("sending (5): " + cmd);

			let sending = browser.runtime.sendNativeMessage(
			"goldendict_helper",
			JSON.stringify({"cmd": cmd}));
			sending.then(onResponse, onError);

		
		}
		



	}


}


browser.contextMenus.create({title: "GoldenDict", contexts:["selection"]});

browser.contextMenus.onClicked.addListener(call_goldendict);


browser.runtime.onMessage.addListener(function (msg, sender){
		
	if ((msg.from === 'options') && (msg.subject === 'settings'))
	{
		if (!log)
		console.log('received message from options');

		try
		{
			let o = Object.create(null);

			if (gd.settings)
			{
				delete gd.settings;
			}
			
			gd.settings = JSON.parse(msg.settings);
			log = ((gd.settings) && (gd.settings.log === true||gd.settings.log === false)) ? gd.settings.log : false;
			
			browser.runtime.sendMessage({
				  from:    'background',
				  subject: 'info',
				  text: 'Accepted'
			});
			
		}
		catch(e)
		{


			browser.runtime.sendMessage({
				  from:    'background',
				  subject: 'info',
				  text: e.message
			});
		
			
		}
		
	}
		
			
});


let getting = browser.storage.local.get("settings");

getting.then((result)=>{

		try
		{

			if (gd.settings)
			{
				delete gd.settings;
			}
			
			gd.settings = JSON.parse(result.settings);
			log = ((gd.settings) && (gd.settings.log === true||gd.settings.log === false)) ? gd.settings.log : false;

			if (!log)
			console.log("getting data from local storage");

		}
		catch(e)
		{
			console.log(e.message);
			
		}
		

	}, (error)=>{
	
	console.log(`Error: ${error}`);	
	
});
